package accountlogic

import (
	"context"

	"code.30cm.net/digimon/app-cloudep-member-server/gen_result/pb/member"
	"code.30cm.net/digimon/app-cloudep-member-server/internal/svc"

	"github.com/zeromicro/go-zero/core/logx"
)

type LineCodeToAccessTokenLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewLineCodeToAccessTokenLogic(ctx context.Context, svcCtx *svc.ServiceContext) *LineCodeToAccessTokenLogic {
	return &LineCodeToAccessTokenLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// LineCodeToAccessToken Line 驗證相關
func (l *LineCodeToAccessTokenLogic) LineCodeToAccessToken(in *member.LineGetTokenReq) (*member.LineAccessTokenResp, error) {
	token, err := l.svcCtx.AccountUseCase.LineCodeToAccessToken(l.ctx, in.GetCode())
	if err != nil {
		return nil, err
	}

	return &member.LineAccessTokenResp{
		Token: token.AccessToken,
	}, nil
}
