package accountlogic

import (
	"context"

	"code.30cm.net/digimon/app-cloudep-member-server/gen_result/pb/member"
	"code.30cm.net/digimon/app-cloudep-member-server/internal/svc"

	"github.com/zeromicro/go-zero/core/logx"
)

type LineGetProfileByAccessTokenLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewLineGetProfileByAccessTokenLogic(ctx context.Context, svcCtx *svc.ServiceContext) *LineGetProfileByAccessTokenLogic {
	return &LineGetProfileByAccessTokenLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// LineGetProfileByAccessToken Line 驗證相關
func (l *LineGetProfileByAccessTokenLogic) LineGetProfileByAccessToken(in *member.LineGetUserInfoReq) (*member.LineUserProfile, error) {
	user, err := l.svcCtx.AccountUseCase.LineGetProfileByAccessToken(l.ctx, in.GetToken())
	if err != nil {
		return nil, err
	}

	return &member.LineUserProfile{
		DisplayName:   user.DisplayName,
		UserId:        user.UserID,
		PictureUrl:    user.PictureURL,
		StatusMessage: user.StatusMessage,
	}, nil
}
